Subject: Re: Patch: Make linkwatch more robust against rtnl holders

From: Stefan Rompf <[email-masked]>
Date: Fri, 20 Feb 2004 17:44:21 +0100

Hi David,

> > the attached patch updates the linkwatch code so that it backs off and
> > retries whenever it cannot get the rtnl semaphore.
>
> I think we should fix locking conflicts created by things like what
> the sungem driver is doing instead.

On the other hand, I'm not aware of any convention when flush_scheduled_work() 
is allowed to be called. As long as anyone inside kernel space is can 
schedule work and anyone else can wait for completion, it does not hurt to 
make a schedule task less vulnerable to deadlocks.

Stefan